#include <stdio.h>
#include <stdlib.h>
#include <kohn_avi.h>

#define MIN_DC_COUNT 200
#define BUFFER_SIZE 131072

static const char *dc={ "00dc" };

int count_00dc(FILE *in)
{
int count,ptr;
long pos;
int ch;

  count=0;
  ptr=0;
  pos=ftell(in);

  while(1)
  {
    ch=getc(in);
    if (ch==EOF) break;

    if (ch==dc[ptr])
    {
      ptr++;
      if (ptr==4)
      {
        count++;
        ptr=0;
      }
    }
      else
    { ptr=0; }
  }

  fseek(in,pos,SEEK_SET);

  return count;
}

int fix_avi(FILE *in, char *filename)
{
struct kavi_t *kavi;
unsigned char buffer[BUFFER_SIZE];
int count,ptr;
int len;
int ch;

  count=0;
  ptr=0;

  kavi=kavi_open(filename,720,480,"xvid",30,NULL);

  while(1)
  {
    ch=getc(in);
    if (ch==EOF) break;

    if (ch==dc[ptr])
    {
      ptr++;
      if (ptr==4)
      {
        len=getc(in);
        len=len|getc(in)<<8;
        len=len|getc(in)<<16;
        len=len|getc(in)<<24;
        if (len!=0 && len<=BUFFER_SIZE)
        {
          fread(buffer,1,len,in);
          kavi_add_frame(kavi, buffer, len);
        }
          else
        {
          printf("Bad frame size of %d on %d.\n",len,count);
        }

        count++;
        ptr=0;
      }
    }
      else
    { ptr=0; }
  }

  kavi_close(kavi);

  return count;
}

int main(int argc, char *argv[])
{
FILE *in;
int dc_count;

  if (argc!=3)
  {
    printf("Usage: %s <infile> <outfile>\n",argv[0]);
    exit(0);
  }

  in=fopen(argv[1],"rb");
  if (in==0)
  {
    printf("Could not open infile %s\n",argv[1]);
    exit(1);
  }

  dc_count=count_00dc(in);
  printf("Found %d avi frame markers.\n",dc_count);

  if (dc_count>MIN_DC_COUNT)
  {
    printf("Making a new avi...\n");
    fix_avi(in,argv[2]);
  }
    else
  {
    printf("Not enough avi frames to even justify fixing.  Counted %d.\nCome back when you downloaded more.\n",dc_count);
  }

  fclose(in);

  return 0;
}

